package com.nesterovskyBros.annotation.processor.eclipse;

import org.eclipse.jdt.internal.compiler.ast.ASTNode;

/**
 * A scope info.
 */
public abstract class Scope
{
  /**
   * Creates a {@link Scope} instance.
   * @param parent a parent scope.
   * @param node a tree node.
   */
  public Scope(Scope parent, ASTNode node)
  {
    this.parent = parent;
    this.node = node;
  }
  
  /**
   * Refactors a scope.
   */
  public abstract void refactor(); 

  /**
   * A tree node.
   */
  public ASTNode node;

  /**
   * A parent scope.
   */
  public Scope parent;

  /**
   * A target scope.
   */
  public Scope target;
  
  /**
   * A label variable.
   */
  public char[] labelName;

  /**
   * Continue label.
   */
  public Label iterationLabel;

  /**
   * Break label.
   */
  public Label breakLabel;

  /**
   * Finally label.
   */
  public Label finallyLabel;
}