package com.nesterovskyBros.annotation.processor.javac;

import com.sun.tools.javac.tree.JCTree;
import com.sun.tools.javac.tree.JCTree.JCCase;
import com.sun.tools.javac.util.Name;

/**
 * A scope info.
 */
public abstract class Scope
{
  /**
   * Creates a {@link Scope} instance.
   * @param parent a parent scope.
   * @param node a tree node.
   */
  public Scope(Scope parent, JCTree node)
  {
    this.parent = parent;
    this.node = node;
  }
  
  /**
   * Refactors a scope.
   */
  public abstract void refactor();

  /**
   * A tree node.
   */
  public JCTree node;

  /**
   * A parent scope.
   */
  public Scope parent;

  /**
   * A target scope.
   */
  public Scope target;
  
  /**
   * A label variable.
   */
  public Name labelName;

  /**
   * Continue label.
   */
  public JCCase iterationLabel;

  /**
   * Break label.
   */
  public JCCase breakLabel;

  /**
   * Finally label.
   */
  public JCCase finallyLabel;
}